; XTIDE Universal BIOS r625: GNU/GPL 2.0 2023-02-19;
; XUB loading floppy bootsector for 15 SPT floppies (this file):
;      |-> by BurnedPinguin: GNU/GPL 2.0 2024-01-09.
; Greetz: 640KB

        TITLE BP1
_TEXT   SEGMENT
        ASSUME CS:_TEXT,DS:_TEXT,ES:_TEXT,SS:_TEXT
        ORG     00H

START:
    MOV AX, 40H
    MOV DS, AX                  ; DS to BDA
    MOV AX, WORD PTR DS:[13H]   ; get original size in KiB
    SUB AX, 8                   ; steal 8k
    MOV WORD PTR DS:[13H], AX   ; write back to BDA
    MOV CL, 6                   ; shift counter for conversion to segment
    SHL AX, CL                  ; AX = segment for your 8k of code
    MOV ES, AX
    PUSH ES
    XOR BX, BX
    MOV AH, 02H
    MOV AL, 0EH
    MOV CH, 00H
    MOV CL, 02H
    MOV DH, 00H
    MOV DL, 00H
    INT 13H
    MOV BX, 1C00H
    MOV AH, 02H
    MOV AL, 02H
    MOV CH, 00H
    MOV CL, 01H
    MOV DH, 01H
    MOV DL, 00H
    INT 13H
    MOV SI, 3
    PUSH SI
    MOV BP, SP
    CALL DWORD PTR [BP]
    INT 19H


    

_TEXT ENDS
END START